{
          
                
              The DoorKit!
              
             
The BBS Door Development Kit By The People - For The People!


   Feel free to modify or optimize this code at will. All I ask is that if
   find a better way to do things (and you will), please send me a copy of
   your modifications. Thanks in advance!....Larry L. Athey....

   This unit is a basic FidoNet *.MSG message base access unit to aid you
   in the creation of Inter-BBS games. Keep in mind that you will need to
   have a basic knowledge of Fido technology and Inter-BBS gaming...Using
   this unit allows you to read and write *.MSG messages, and file attach
   Inter-BBS game/score packets to the messages.                                }

{$I DEFINES.INC}
UNIT FIDOUNIT;

INTERFACE

CONST Max_Msg_Lines = 800;    {This is actually non standard, *.MSG files   }
                              {are actually only suppose to have a maximum  }
                              {of 99 lines. However, everybody and their dog}
                              {that writes *.MSG compatible programs ignore }
                              {that rule because they realize that 99 lines }
                              {is just way too limited to be practical...   }

TYPE TextBuffer  = ARRAY[1..Max_Msg_Lines] OF STRING[80];
{^ NOTE: This unit uses a pointer array for storing the message text, so you}
{        will always need to call NEW(Cur_Msg.TBuff) before using procedures}
{        in this unit...You will also have to call DISPOSE(Cur_Msg.TBuff) as}
{        soon as you are done, or you will lose 64K of conventional memory..}

TYPE Message_Rec = RECORD     {Geez, guess what this record is for...Duh?   }
     From_Name   : STRING[35];{Notice that there aren't any Zone variables? }
     To_Name     : STRING[35];{That's because the *.MSG message format is a }
     Subject     : STRING[72];{FidoNet creation, and FidoNet originally only}
     Date_Time   : STRING[19];{had one zone (Zone 1). 'INTL' message kludge }
     TimesRead,               {lines were added later to support more zones.}
     DestNode,
     OrigNode,
     Cost,
     OrigNet,
     DestNet,
     ReplyTo,
     Attribute,
     NextReply   : WORD;
     Junk        : ARRAY[1..12] OF BYTE;
     Lines       : INTEGER;
     TBuff       : ^TextBuffer;
     END;

VAR
  {You will notice that there are some redundant variables listed below. I'm}
  {not sure who is/isn't familiar with records, so it helps simplify things.}
  Cur_Msg      : Message_Rec; {The current message data record variable     }
  OldFileMode  : BYTE;        {Used to backup/restore the file mode         }
  NetMailPath  : STRING;      {Path to your *.MSG message base              }
  ExtFlags,                   {Stores the extended message flags            }
  MOrigin,                    {Message origin address in ###:###/### format }
  MDestination,               {Message destin address in ###:###/### format }
  ToName,                     {Message "TO:" name                           }
  FromName     : STRING[35];  {Message "FROM:" name                         }
  Subject,                    {Message "SUBJECT:" line                      }
  PID          : STRING[72];  {The program ID to embed into your messages   }
  {-------------------------------------------------------------------------}
  {The following boolean variables are the actual message flags that are set}
  {during message reading, and must be set before posting a message...All of}
  {these flags are set directly by the Cur_Msg.Attribute WORD...            }
  Priv,                       {Message PRIVATE flag                         }
  Crash,                      {Message CRASH MAIL flag                      }
  Rcvd,                       {Message RECEIVED flag                        }
  Sent,                       {Message SENT flag                            }
  FAtt,                       {Message FILE ATTACHED flag                   }
  InTrans,                    {Message IN TRANSIT flag                      }
  Orphan,                     {Message ORPHANED flag                        }
  KillSent,                   {Message KILL/SENT flag                       }
  Local,                      {Message LOCAL flag                           }
  Hold,                       {Message HOLD flag                            }
  Reserved,                   {This is an unassigned flag, don't use it...  }
  FReq,                       {Message FILE REQUEST flag                    }
  RRR,                        {Message RETURN RECEIPT REQUESTED flag        }
  RR,                         {Message RETURN RECEIPT flag                  }
  Audit,                      {Message AUDIT flag                           }
  UDReq,                      {Message UPDATE REQUEST flag                  }
  {-------------------------------------------------------------------------}
  {The following message flags are actually set by kludge lines found in the}
  {message body. The message body will have a line that has an ASCII #1 with}
  {the word 'FLAGS' immediately after it. After the word 'FLAGS' each of the}
  {message flags to set will be activated by adding the same letters as the }
  {actual variables use (separated by spaces)...                            }
  Imm,                        {Message IMMEDIATE MAIL flag                  }
  Dir,                        {Message DIRECT MAIL flag                     }
  Kfs,                        {Message KILL FILE SENT flag                  }
  Tfs          : BOOLEAN;     {Message TRUNCATE FILE SENT flag              }

{--[Headers]-}

PROCEDURE InitMsgData;
{^ This procedure must be called before posting any text files. After you've}
{  called this procedure, you set all of your variables and then make a call}
{  to the PostTextFile procedure.                                           }
FUNCTION  GetBit(The_Bit : WORD; Which_Bit : BYTE) : BOOLEAN;
{^ This function returns the status of a message attribute.                 }
PROCEDURE SetBit(VAR The_Bit : WORD; Which_Bit : BYTE; SetIt : BOOLEAN);
{^ This procedure allows you to set the status of a message attribute.      }
PROCEDURE ToggleBit(VAR The_Bit : WORD; Which_Bit : BYTE);
{^ This procedure allows you to toggle the status of a message attribute.   }
PROCEDURE Get_Message(File_Name : STRING; VAR Cur_Msg : Message_Rec);
{^ This procedure reads a *.MSG file, sets all variables accordingly, and   }
{  puts the message into Cur_Msg.TBuff^[1..800].                            }
PROCEDURE Write_Message(File_Name : STRING; VAR Cur_Msg : Message_Rec);
{^ This procedure is for the experts who already set all of the message and }
{  attribute data with their own procedures and then write a new *.MSG file.}
FUNCTION  Find_High_Message(Path : STRING) : WORD;
{^ This function returns the highest message number in your NetMailPath.    }
PROCEDURE PostTextFile(TextFile : STRING);
{^ This procedure is a painless and nearly hands free method of posting a   }
{  text file as a netmail message. See the InitMsgData procedure.           }

IMPLEMENTATION

USES DOS,CRCUNIT,DOORKIT2;

{}
PROCEDURE InitMsgData;
BEGIN
  MOrigin      := '';
  MDestination := '';
  ToName       := '';
  FromName     := '';
  Subject      := '';
  Priv         := FALSE;
  Crash        := FALSE;
  Rcvd         := FALSE;
  Sent         := FALSE;
  FAtt         := FALSE;
  InTrans      := FALSE;
  Orphan       := FALSE;
  KillSent     := FALSE;
  Local        := FALSE;
  Hold         := FALSE;
  Reserved     := FALSE;
  FReq         := FALSE;
  RRR          := FALSE;
  RR           := FALSE;
  Audit        := FALSE;
  UDReq        := FALSE;
  Imm          := FALSE;
  Dir          := FALSE;
  Kfs          := FALSE;
  Tfs          := FALSE;
  ExtFlags     := #1 + 'FLAGS';
  FILLCHAR(Cur_Msg.TBuff^,SIZEOF(Cur_Msg.TBuff^),0);
END;
{}
FUNCTION GetBit(The_Bit : WORD; Which_Bit : BYTE) : BOOLEAN;
BEGIN
  IF (The_Bit AND (1 SHL Which_Bit)) <> 0 THEN GetBit := TRUE ELSE GetBit := FALSE;
END;
{}
PROCEDURE SetBit(VAR The_Bit : WORD; Which_Bit : BYTE; SetIt : BOOLEAN);
BEGIN
  IF SetIt THEN The_Bit := The_Bit OR (1 SHL Which_Bit) ELSE The_Bit := The_Bit AND NOT (1 SHL Which_Bit);
END;
{}
PROCEDURE ToggleBit(VAR The_Bit : WORD; Which_Bit : BYTE);
BEGIN
  IF GetBit(The_Bit,Which_Bit) THEN SetBit(The_Bit,Which_Bit,FALSE) ELSE SetBit(The_Bit,Which_Bit,TRUE);
END;
{}
PROCEDURE GetExtendedFlags;
VAR
  Loop : INTEGER;
BEGIN
  IF Cur_Msg.Lines = 0 THEN EXIT;
  FOR Loop := 1 TO Cur_Msg.Lines DO BEGIN
    IF POS(#1'FLAGS',Cur_Msg.TBuff^[Loop]) = 1 THEN BEGIN
      IF POS('IMM',Cur_Msg.TBuff^[Loop]) > 0 THEN Imm := TRUE;
      IF POS('DIR',Cur_Msg.TBuff^[Loop]) > 0 THEN Dir := TRUE;
      IF POS('KFS',Cur_Msg.TBuff^[Loop]) > 0 THEN Kfs := TRUE;
      IF POS('TFS',Cur_Msg.TBuff^[Loop]) > 0 THEN Tfs := TRUE;
      EXIT;
    END;
  END;
END;
{}
PROCEDURE GetNodeNumbers;
VAR
  Loop : INTEGER;
  X    : BYTE;
  S    : STRING;
BEGIN
  IF Cur_Msg.Lines > 0 THEN FOR Loop := 1 TO Cur_Msg.Lines DO BEGIN
    IF POS(#1'INTL',Cur_Msg.TBuff^[Loop]) = 1 THEN BEGIN
      S := Cur_Msg.TBuff^[Loop];
      DELETE(S,1,6);
      S := StripBoth(S,' ');
      X := POS(' ',S);
      MDestination := COPY(S,1,X - 1);
      MOrigin      := COPY(S,X + 1,255);
      EXIT;
    END;
  END;
  MDestination := '1:' + IntToStr(Cur_Msg.DestNet) + '/' + IntToStr(Cur_Msg.DestNode);
  MOrigin      := '1:' + IntToStr(Cur_Msg.OrigNet) + '/' + IntToStr(Cur_Msg.OrigNode);
END;
{}
PROCEDURE Get_Message(File_Name : STRING; VAR Cur_Msg : Message_Rec);
TYPE Msg_Buff     = ARRAY[1..65535] OF CHAR;
     Msg_Buff_Ptr = ^Msg_Buff;
VAR
  SS              : ARRAY[1..2] OF CHAR;
  C               : INTEGER ABSOLUTE SS;
  D,L,A,Bfcnt     : WORD;
  Message_Buffer  : Msg_Buff_Ptr;
  F               : FILE;
  B               : BOOLEAN;
  Ch              : CHAR;
  S               : STRING;
BEGIN
  InitMsgData;
  OldFileMode := FileMode;
  FileMode    := 64;
  ASSIGN(F,FixPath(NetMailPath) + File_Name);
  {$I-}
  FileMode := 66;
  RESET(F,128);
  FileMode := 2;
  {$I+}
  IF IORESULT <> 0 THEN Cur_Msg.From_Name := 'DELETED' ELSE BEGIN
    WITH Cur_Msg DO BEGIN
      From_Name := '';
      To_Name   := '';
      Subject   := '';
    END;
    GETMEM(Message_Buffer,(FILESIZE(F) + 2) * 128);
    FOR A := 1 TO (FILESIZE(F) + 2) * 128 DO Message_Buffer^[A] := #0;
    BLOCKREAD(F,Message_Buffer^,FILESIZE(F) + 1,A);
    B := TRUE;
    FOR A := 1 TO 36 DO BEGIN
      IF Message_Buffer^[A] = #0 THEN B := FALSE;
      IF B THEN Cur_Msg.From_Name := Cur_Msg.From_Name + Message_Buffer^[A];
    END;
    B := TRUE;
    FOR A := 37 TO 73 DO BEGIN
      IF Message_Buffer^[A] = #0 THEN B := FALSE;
      IF B THEN Cur_Msg.To_Name := Cur_Msg.To_Name + Message_Buffer^[A];
    END;
    B := TRUE;
    FOR A := 73 TO 145 DO BEGIN
      IF Message_Buffer^[A] = #0 THEN B := FALSE;
      IF B THEN Cur_Msg.Subject := Cur_Msg.Subject + Message_Buffer^[A];
    END;
    B := TRUE;
    FOR A := 145 TO 165 DO BEGIN
      IF Message_Buffer^[A] = #0 THEN B := FALSE;
      IF B THEN Cur_Msg.Date_Time := Cur_Msg.Date_Time + Message_Buffer^[A];
    END;
    SS[1] := Message_Buffer^[167];
    SS[2] := Message_Buffer^[168];
    Cur_Msg.DestNode := C;
    SS[1] := Message_Buffer^[169];
    SS[2] := Message_Buffer^[170];
    Cur_Msg.OrigNode := C;
    SS[1] := Message_Buffer^[171];
    SS[2] := Message_Buffer^[172];
    Cur_Msg.Cost := C;
    SS[1] := Message_Buffer^[173];
    SS[2] := Message_Buffer^[174];
    Cur_Msg.OrigNet := C;
    SS[1] := Message_Buffer^[175];
    SS[2] := Message_Buffer^[176];
    Cur_Msg.DestNet := C;
    SS[1] := Message_Buffer^[185];
    SS[2] := Message_Buffer^[186];
    Cur_Msg.ReplyTo := C;
    SS[1] := Message_Buffer^[187];
    SS[2] := Message_Buffer^[188];
    Cur_Msg.Attribute := C;
    SS[1] := Message_Buffer^[189];
    SS[2] := Message_Buffer^[190];
    Cur_Msg.NextReply := C;
    L := 1;
    FOR A := 1 TO Max_Msg_Lines DO Cur_Msg.TBuff^[A] := '';
    Bfcnt := 191;
    REPEAT
      Ch    := Message_Buffer^[Bfcnt];
      Bfcnt := SUCC(Bfcnt);
      IF Ch = #$0D THEN INC(L);
      IF NOT (Ch IN [#$0d,#$8d,#$0a,#0]) THEN Cur_Msg.TBuff^[L] := Cur_Msg.TBuff^[L] + Ch;
      IF (LENGTH(Cur_Msg.TBuff^[L]) = 79) THEN BEGIN
        D := 0;
        FOR C := LENGTH(Cur_Msg.TBuff^[l]) DOWNTO 1 DO BEGIN
          IF (D = 0) AND (Cur_Msg.TBuff^[L][C] = ' ') THEN D := C;
        END;
        S := '';
        IF D > 60 THEN BEGIN
          WHILE LENGTH(Cur_Msg.TBuff^[L]) >= D DO BEGIN
            S := S + Cur_Msg.TBuff^[L][LENGTH(Cur_Msg.TBuff^[L])];
            DELETE(Cur_Msg.TBuff^[L],LENGTH(Cur_Msg.TBuff^[L]),1);
          END;
          FOR A := LENGTH(S) - 1 DOWNTO 1 DO Cur_Msg.TBuff^[L + 1] := Cur_Msg.TBuff^[L + 1] + S[A];
        END;
        INC(L);
      END;
      IF L >= (Max_Msg_Lines - 1) THEN BEGIN
        Cur_Msg.TBuff^[Max_Msg_Lines - 1] := '--- Error: Message Length Exceeds Line Limit!';
        L  := Max_Msg_Lines;
        Ch := #0;
      END;
    UNTIL Ch = CHR(0);
    Cur_Msg.Lines := L;
    FREEMEM(Message_Buffer,(FILESIZE(F) + 2) * 128);
    CLOSE(F);
    FromName := Cur_Msg.From_Name;
    ToName   := Cur_Msg.To_Name;
    Subject  := Cur_Msg.Subject;
    Priv     := GetBit(Cur_Msg.Attribute,0);
    Crash    := GetBit(Cur_Msg.Attribute,1);
    Rcvd     := GetBit(Cur_Msg.Attribute,2);
    Sent     := GetBit(Cur_Msg.Attribute,3);
    FAtt     := GetBit(Cur_Msg.Attribute,4);
    InTrans  := GetBit(Cur_Msg.Attribute,5);
    Orphan   := GetBit(Cur_Msg.Attribute,6);
    KillSent := GetBit(Cur_Msg.Attribute,7);
    Local    := GetBit(Cur_Msg.Attribute,8);
    Hold     := GetBit(Cur_Msg.Attribute,9);
    Reserved := GetBit(Cur_Msg.Attribute,10);
    FReq     := GetBit(Cur_Msg.Attribute,11);
    RRR      := GetBit(Cur_Msg.Attribute,12);
    RR       := GetBit(Cur_Msg.Attribute,13);
    Audit    := GetBit(Cur_Msg.Attribute,14);
    UDReq    := GetBit(Cur_Msg.Attribute,15);
    GetExtendedFlags;
    GetNodeNumbers;
  END;
  {$I-}
  FileMode := OldFileMode;
END;
{}
PROCEDURE Write_Message(File_Name : STRING; VAR Cur_Msg : Message_Rec);
VAR
  F             : FILE OF CHAR;
  I,I1          : INTEGER;
  Ch,Ch1,Cr,
  Space,Soft_Cr : CHAR;
  SS            : ARRAY[1..10] OF CHAR;
BEGIN
  Space := #32; Ch := #0; Ch1 := #01; Cr := #$0d; Soft_Cr := #$08d;
  WHILE LENGTH(Cur_Msg.Subject) > 71 DO DELETE(Cur_Msg.Subject,LENGTH(Cur_Msg.Subject),1);
  I1 := 0;
  ASSIGN(F,FixPath(NetMailPath) + File_Name);
  REWRITE(F);
  FOR I := 1 TO LENGTH(Cur_Msg.From_Name) DO BEGIN
    WRITE(F,Cur_Msg.From_Name[I]);
    INC(I1);
  END;
  WHILE I1 < 36 DO BEGIN
    WRITE(F,Ch);
    INC(I1);
  END;
  FOR I := 1 TO LENGTH(Cur_Msg.To_Name) DO BEGIN
    WRITE(F,Cur_Msg.To_Name[I]);
    INC(I1);
  END;
  WHILE I1 < 72 DO BEGIN
    WRITE(F,Ch);
    INC(I1);
  END;
  FOR I := 1 TO LENGTH(Cur_Msg.Subject) DO BEGIN
    WRITE(F,Cur_Msg.Subject[I]);
    INC(I1);
  END;
  WHILE I1 < 144 DO BEGIN
    WRITE(F,Ch);
    INC(I1);
  END;
  FOR I := 1 TO LENGTH(Cur_Msg.Date_Time) DO BEGIN
    WRITE(F,Cur_Msg.Date_Time[I]);
    INC(I1);
  END;
  WHILE I1 < 164 DO BEGIN
    WRITE(F,Ch);
    INC(I1);
  END;
  WRITE(F,Ch1,Ch);
  WITH Cur_Msg DO BEGIN
    SS[1]  := CHR(LO(DestNode));
    SS[2]  := CHR(HI(DestNode));
    SS[3]  := CHR(LO(OrigNode));
    SS[4]  := CHR(HI(OrigNode));
    SS[5]  := CHR(LO(Cost));
    SS[6]  := CHR(HI(Cost));
    SS[7]  := CHR(LO(OrigNet));
    SS[8]  := CHR(HI(OrigNet));
    SS[9]  := CHR(LO(DestNet));
    SS[10] := CHR(HI(DestNet));
    FOR I := 1 TO 10 DO WRITE(F,SS[I]);
    WRITE(F,Ch,Ch,Ch,Ch,Ch,Ch,Ch,Ch);
    SS[1] := CHR(LO(ReplyTo));
    SS[2] := CHR(HI(ReplyTo));
    SS[3] := CHR(LO(Attribute));
    SS[4] := CHR(HI(Attribute));
    SS[5] := CHR(LO(NextReply));
    SS[6] := CHR(HI(NextReply));
    FOR I := 1 TO 6 DO WRITE(F,SS[I]);
  END;
  FOR I := 1 TO Cur_Msg.Lines DO BEGIN
    FOR I1 := 1 TO LENGTH(Cur_Msg.TBuff^[I]) DO WRITE(F,Cur_Msg.TBuff^[I][I1]);
    IF Cur_Msg.TBuff^[I][LENGTH(Cur_Msg.TBuff^[I])] <> #13 THEN WRITE(F,Space);
  END;
  WRITE(F,Ch);
  CLOSE(F);
END;
{}
FUNCTION Find_High_Message(Path : STRING) : WORD;
VAR
  SR          : SEARCHREC;
  A,B,HighMsg : INTEGER;
  S           : STRING;
BEGIN
  HighMsg := 0; S := ''; Path := FixPath(Path);
  FINDFIRST(Path + '*.MSG',Anyfile,SR);
  FOR A := 1 TO POS('.',SR.Name) - 1 DO S := S + SR.Name[A];
  A := StrToInt(S);
  IF A <> 0 THEN IF A > HighMsg THEN HighMsg := A;
  WHILE DOSERROR = 0 DO BEGIN
    FINDNEXT(SR);
    S := '';
    FOR A := 1 TO POS('.',SR.Name) - 1 DO S := S + SR.Name[A];
    A := StrToInt(S);
    IF A <> 0 THEN IF A > HighMsg THEN HighMsg := A;
  END;
  Find_High_Message := HighMsg;
END;
{}
FUNCTION FidoDate : STRING;
CONST
  Months : ARRAY[1..12] OF STRING[3] = ('Jan','Feb','Mar','Apr',
                                        'May','Jun','Jul','Aug',
                                        'Sep','Oct','Nov','Dec');
VAR
  Y,M,D,W,H,MN,SC,S100 : WORD;
  S,S2,S3              : STRING;
BEGIN
  GETDATE(Y,M,D,W);
  S3 := IntToStr(Y);
  DELETE(S3,1,2); {Actual Y2K compatible 2 digit year. You don't use Y-1900}
  S := IntToStr(D);
  IF LENGTH(S) = 1 THEN S := '0' + S;
  S := S + ' ' + Months[M] + ' ' + S3 + '  ';
  GETTIME(H,MN,SC,S100);
  S2 := IntToStr(H);
  IF LENGTH(S2) = 1 THEN S2 := '0' + S2;
  S := S + S2 + ':'; S2 := IntToStr(MN);
  IF LENGTH(S2) = 1 THEN S2 := '0' + S2;
  S := S + S2 + ':'; S2 := IntToStr(SC);
  IF LENGTH(S2) = 1 THEN S2 := '0' + S2;
  S := S + S2;
  S := S + #0;
  WHILE LENGTH(S) > 20 DO DELETE(S,LENGTH(S),1);
  FidoDate := S;
END;
{}
PROCEDURE PostTextFile(TextFile : STRING);
VAR
  ONetStr,
  ONodeStr,
  DNetStr,
  DNodeStr,
  OZone,
  DZone    : STRING[4];
  NetGo,
  NodeGo,
  ZoneGo   : BOOLEAN;
  Temp     : STRING[85];
  Loop     : BYTE;
  MsgNum   : WORD;
  MsgTxt   : TEXT;
BEGIN
  ZoneGo := TRUE; NetGo := FALSE; NodeGo := FALSE;
  OZone := ''; ONetStr := ''; ONodeStr := '';
  FOR Loop := 1 TO LENGTH(MOrigin) DO BEGIN
    IF MOrigin[Loop - 1] = ':' THEN BEGIN
      NetGo  := TRUE;
      ZoneGo := FALSE;
    END;
    IF MOrigin[Loop] = '/' THEN NetGo := FALSE;
    IF MOrigin[Loop - 1] = '/' THEN NodeGo := TRUE;
    IF MOrigin[Loop] = '.' THEN NodeGo := FALSE;
    IF MOrigin[Loop] = '@' THEN NodeGo := FALSE;
    IF ZoneGo THEN    OZone := OZone + MOrigin[Loop];
    IF NetGo  THEN  ONetStr := ONetStr + MOrigin[Loop];
    IF NodeGo THEN ONodeStr := ONodeStr + MOrigin[Loop];
  END;
  ZoneGo := TRUE; NetGo := FALSE; NodeGo := FALSE;
  DZone := ''; DNetStr := ''; DNodeStr := '';
  FOR Loop := 1 TO LENGTH(MDestination) DO BEGIN
    IF MDestination[Loop - 1] = ':' THEN BEGIN
      NetGo  := TRUE;
      ZoneGo := FALSE;
    END;
    IF MDestination[Loop] = '/' THEN NetGo := FALSE;
    IF MDestination[Loop - 1] = '/' THEN NodeGo := TRUE;
    IF MDestination[Loop] = '.' THEN NodeGo := FALSE;
    IF MDestination[Loop] = '@' THEN NodeGo := FALSE;
    IF ZoneGo THEN    DZone := DZone + MDestination[Loop];
    IF NetGo  THEN  DNetStr := DNetStr + MDestination[Loop];
    IF NodeGo THEN DNodeStr := DNodeStr + MDestination[Loop];
  END;
  MsgNum            := Find_High_Message(NetmailPath) + 1;
  Cur_Msg.From_Name := FromName;
  Cur_Msg.To_Name   := ToName;
  Cur_Msg.Subject   := Subject;
  Cur_Msg.Date_Time := FidoDate;
  Cur_Msg.OrigNet   := StrToInt(ONetStr);
  Cur_Msg.OrigNode  := StrToInt(ONodeStr);
  Cur_Msg.DestNet   := StrToInt(DNetStr);
  Cur_Msg.DestNode  := StrToInt(DNodeStr);
  SetBit(Cur_Msg.Attribute,0,Priv);
  SetBit(Cur_Msg.Attribute,1,Crash);
  SetBit(Cur_Msg.Attribute,2,Rcvd);
  SetBit(Cur_Msg.Attribute,3,Sent);
  SetBit(Cur_Msg.Attribute,4,FAtt);
  SetBit(Cur_Msg.Attribute,5,InTrans);
  SetBit(Cur_Msg.Attribute,6,Orphan);
  SetBit(Cur_Msg.Attribute,7,KillSent);
  SetBit(Cur_Msg.Attribute,8,Local);
  SetBit(Cur_Msg.Attribute,9,Hold);
  SetBit(Cur_Msg.Attribute,10,Reserved);
  SetBit(Cur_Msg.Attribute,11,FReq);
  SetBit(Cur_Msg.Attribute,12,RRR);
  SetBit(Cur_Msg.Attribute,13,RR);
  SetBit(Cur_Msg.Attribute,14,Audit);
  SetBit(Cur_Msg.Attribute,15,UDReq);
  ExtFlags := #1 + 'FLAGS';
  IF Imm THEN ExtFlags := ExtFlags + ' IMM';
  IF Dir THEN ExtFlags := ExtFlags + ' DIR';
  IF Kfs THEN ExtFlags := ExtFlags + ' KFS';
  IF Tfs THEN ExtFlags := ExtFlags + ' TFS';
  Cur_Msg.TBuff^[1] := #1 + 'INTL ' + MDestination + ' ' + MOrigin + #13;
  Cur_Msg.TBuff^[2] := #1 + 'MSGID: ' + MOrigin + ' ' + StringToCrc(FromName + Cur_Msg.Date_Time) + #13;
  Cur_Msg.TBuff^[3] := #1 + 'PID: ' + PID + #13;
  IF LENGTH(ExtFlags) > 6 THEN BEGIN
    Cur_Msg.TBuff^[4] := ExtFlags + #13;
    Loop := 4;
  END ELSE Loop := 3;
  ASSIGN(MsgTxt,TextFile);
  RESET(MsgTxt);
  WHILE NOT EOF(MsgTxt) DO BEGIN
    INC(Loop);
    READLN(MsgTxt,Temp);
    Temp := StripTrail(Temp,' ');
    Cur_Msg.TBuff^[Loop] := Temp + #13;
  END;
  CLOSE(MsgTxt);
  Cur_Msg.Lines := Loop;
  Write_Message(IntToStr(MsgNum) + '.MSG',Cur_Msg);
END;
{}
END.
