{
          
                
              The DoorKit!
              
             
The BBS Door Development Kit By The People - For The People!

   Feel free to modify or optimize this code at will. All I ask is that if
   find a better way to do things (and you will), please send me a copy of
   your modifications. Thanks in advance!....Larry L. Athey....}

{ -- Version 98-02-06 13:00 BST --

  PROTOCOL.PAS: Interface to BBS Utiliteez Software's PDRIVE, a FreeWare
                Multi-Tasker Friendly Protocol Driver

  Public domain software by

  Dwayne Heaton, Sysop of Virtual Maddness BBS, Berkshire, UK.
  BBS/FAX: +44-1344-422575, Fido: 2:252/314, email: dwayne@vmadd.demon.co.uk

  History:

  98-02-06   Added support for MaxModem protocol. SEE NOTE BELOW.
             Removed size check of PDRIVE to determine version. PDRIVE v2.10
             can return the version number, but call is INCOMPATIBLE with
             previous versions.

  97-09-29   Changed the routines that detect PDRIVE. They now run when the
             unit is initialized. Automatically locates PDRIVE and works out
             which version is installed (works by file size, until I can
             figure out a better way)

             Added support for PDRIVE v1.20's new command line options. It
             will only use them if version 1.20 was detected.
}

{ Adjust your compiler directives as you see fit }
{$I DEFINES.INC}
Unit Protocol;

{.$DEFINE VERSIONCHECK}

{ Remove the '.' in the above define to include the new and improved version
  checking routines. The only problem is that they will only work with PDRIVE
  versions 2.10 and above and will leave previous versions in the COMMANDLINE
  PARAMETERS help screen. YOU HAVE BEEN WARNED

  If you leave VERSIONCHECK undefined, this unit will use PDRIVE v1.10 'mode'
  ie no MaxModem support or ActivityLog }

Interface

Uses _EXIT, DOS;

Const
   ProtocolError   : Integer = 0;
   ProtocolErrMsg  : String = '';
   FatalError      : Boolean = False;

   PDriveInstalled : Boolean = False;
   PDriveLocation  : String = '';
{$IFDEF VERSIONCHECK}
   ActivityLog     : String = '';
   PDriveVersion   : Word = $FFFF;
{$ENDIF}

Var
   SendArray     : Array[1..15] of PathStr;
   FileCount     : Byte;
   UserProtocol  : Char; { L - Local }
                         { X - Xmodem }
                         { 1 - Xmodem1k }
                         { Y - Ymodem }
                         { G - YmodemG }
                         { Z - Zmodem }
                         { M - MaxModem }
   DstPath     : String;
   SrcFile     : String;

Function  SelectProtocol(UseMAX : Boolean) : Boolean;
Procedure SetLocal;
Procedure SetXmodem;
Procedure SetXmodem1k;
Procedure SetYmodem;
Procedure SetYmodemG;
Procedure SetZmodem;
{$IFDEF VERSIONCHECK}
Procedure SetMaxModem;
{$ENDIF}

Function  AddSendFile(Filename : String) : Boolean;

Function  Send : Boolean;
Function  Receive(Path : String) : Boolean;

Implementation

Uses CRT, TDK_VARS, DOORKIT1, DOORKIT2, DOORKIT3, MAX_UNIT, EXEC;

Function AddSendFile(Filename : String) : Boolean;
Begin
   AddSendFile := False;
   If (FileCount = 1) and (UserProtocol in ['X', '1']) Then Exit;
   If FileCount = 15 Then Exit;
   If FExist(Filename) Then
   Begin
      Inc(FileCount, 1);
      SendArray[Filecount] := Filename;
      AddSendFile := True;
   End;
End;

Procedure SetLocal;
Begin
   UserProtocol := 'L';
   Log('Local protocol selected');
End;

Procedure SetXmodem;
Begin
   UserProtocol := 'X';
   Log('Xmodem protocol selected');
End;

Procedure SetXmodem1k;
Begin
   UserProtocol := '1';
   Log('Xmodem-1k protocol selected');
End;

Procedure SetYmodem;
Begin
   UserProtocol := 'Y';
   Log('Ymodem protocol selected');
End;

Procedure SetYmodemG;
Begin
   UserProtocol := 'G';
   Log('YmodemG protocol selected');
End;

Procedure SetZmodem;
Begin
   UserProtocol := 'Z';
   Log('Zmodem protocol selected');
End;

{$IFDEF VERSIONCHECK}
Procedure SetMaxModem;
Begin
   UserProtocol := 'M';
   Log('MaxModem protocol selected');
End;
{$ENDIF}

Function SelectProtocol(UseMAX : Boolean) : Boolean;
Var
   Ch : Char;

Begin
   SelectProtocol := True;
   If Not Local Then
   Begin
      Ch := #0;
      Repeat
         If (Graphics = MAX) and UseMax Then
         Begin
            MaxCommand('');
            MaxCommand(#12);
         (*
            MaxCommand('Start_Screen()
{$IFDEF VERSIONCHECK}
            MaxCommand('Draw_Window(225,122,416,352,5,''Please Select A Protocol'')');
            MaxCommand('Draw_Button(230,151,180,88,0,0,'' {1}X{0}modem'')');
            MaxCommand('Draw_Button(230,176,180,49,0,0,'' Xmodem-{1}1{0}k'')');
            MaxCommand('Draw_Button(230,201,180,89,0,0,'' {1}Y{0}modem'')');
            MaxCommand('Draw_Button(230,226,180,71,0,0,'' Ymodem{1}G'')');
            MaxCommand('Draw_Button(230,251,180,90,0,0,'' {1}Z{0}modem'')');
            MaxCommand('Draw_Button(230,276,180,77,0,0,'' {1}M{0}axModem'')');
            MaxCommand('Draw_Button(230,326,180,81,0,0,'' {1}Q{0}uit'')');
{$ELSE}
            MaxCommand('Draw_Window(225,137,416,342,5,''Please Select A Protocol'')'); }
            MaxCommand('Draw_Button(230,166,180,88,0,0,'' {1}X{0}modem'')');
            MaxCommand('Draw_Button(230,191,180,49,0,0,'' Xmodem-{1}1{0}k'')');
            MaxCommand('Draw_Button(230,216,180,89,0,0,'' {1}Y{0}modem'')');
            MaxCommand('Draw_Button(230,241,180,71,0,0,'' Ymodem{1}G'')');
            MaxCommand('Draw_Button(230,266,180,90,0,0,'' {1}Z{0}modem'')');
            MaxCommand('Draw_Button(230,316,180,81,0,0,'' {1}Q{0}uit'')');
{$ENDIF}
            End_Screen()
         *)
            MaxCommand(#255#126#253#255);
{$IFDEF VERSIONCHECK}
            MaxCommand(#255#126#128'225,122,416,352,5,''Please Select A Protocol'''#255);
            MaxCommand(#255#126#130'230,151,180,88,0,0,'' {1}X{0}modem'''#255);
            MaxCommand(#255#126#130'230,176,180,49,0,0,'' Xmodem-{1}1{0}k'''#255);
            MaxCommand(#255#126#130'230,201,180,89,0,0,'' {1}Y{0}modem'''#255);
            MaxCommand(#255#126#130'230,226,180,71,0,0,'' Ymodem{1}G'''#255);
            MaxCommand(#255#126#130'230,251,180,90,0,0,'' {1}Z{0}modem'''#255);
            MaxCommand(#255#126#140'230,276,180,77,0,0,'' {1}M{0}axModem'''#255);
            MaxCommand(#255#126#130'230,376,180,81,0,0,'' {1}Q{0}uit'''#255);
{$ELSE}
            MaxCommand(#255#126#128'225,137,416,342,5,''Please Select A Protocol'''#255);
            MaxCommand(#255#126#130'230,166,180,88,0,0,'' {1}X{0}modem'''#255);
            MaxCommand(#255#126#130'230,191,180,49,0,0,'' Xmodem-{1}1{0}k'''#255);
            MaxCommand(#255#126#130'230,216,180,89,0,0,'' {1}Y{0}modem'''#255);
            MaxCommand(#255#126#130'230,241,180,71,0,0,'' Ymodem{1}G'''#255);
            MaxCommand(#255#126#130'230,266,180,90,0,0,'' {1}Z{0}modem'''#255);
            MaxCommand(#255#126#130'230,316,180,81,0,0,'' {1}Q{0}uit'''#255);
{$ENDIF}
            MaxCommand(#255#126#254#255);
         End Else
         Begin
            sWriteln('');
            InfoText('Please Select A Protocol:');
            sWriteln('');
            LineBar(1,0,33);
            CPrompt('X',' Xmodem');    sWriteln('');
            CPrompt('1',' Xmodem-1k'); sWriteln('');
            CPrompt('Y',' Ymodem');    sWriteln('');
            CPrompt('G',' YmodemG');   sWriteln('');
            CPrompt('Z',' Zmodem');    sWriteln('');
{$IFDEF VERSIONCHECK}
            CPrompt('M',' MaxModem');  sWriteln('');
{$ENDIF}
            CPrompt('Q',' Quit');      sWriteln('');
            LineBar(1,0,33);
            FancyPrompt;
         End;
         Ch := UpCase(sReadKey);
         sWriteln('');
{$IFDEF VERSIONCHECK}
      Until Ch in ['X', '1', 'Y', 'G', 'Z', 'M', 'Q'];
{$ELSE}
      Until Ch in ['X', '1', 'Y', 'G', 'Z', 'Q'];
{$ENDIF}
   End Else
      Ch := 'L';

   Case Ch Of
      'L' : SetLocal;
      'X' : SetXmodem;
      '1' : SetXmodem1k;
      'Y' : SetYmodem;
      'G' : SetYmodemG;
      'Z' : SetZmodem;
{$IFDEF VERSIONCHECK}
      'M' : SetMaxModem;
{$ENDIF}
      'Q' : SelectProtocol := False;
   End;
End;

Procedure ProtocolErr;
Begin
   ProtocolErrMsg := '';
   FatalError := True;

   Case ProtocolError of
      $0000 : FatalError := False;
            { PDrive will exit at error level 0 if everything goes fine }
      $0001 : ProtocolErrMsg := 'PDrive Error : Could not open comport';
            { PDrive will exit at error level 1 if it cannot open the comport }
      $0006 : ProtocolErrMsg := 'PDrive Error : Transfer file/list not found';
            { PDrive will exit at error level 6 if the file specified by the }
            { /F= or /L= command line parameters is not found }
      $0064 : ProtocolErrMsg := 'PDrive Error : User aborted transfer';
            { PDrive will exit at error level 100 if a user aborts an upload }
            { or download. You can trap this error level in your program in }
            { order to prevent users from "Leeching" files from your system }
      $0065 : ProtocolErrMsg := 'PDrive Error : Sysop aborted transfer';
            { PDrive will exit at error level 101 if the upload or download }
            { is aborted locally by you }

      $0101 : ProtocolErrMsg := 'EXEC: Error preparing for swap: no space for swapping';
      $0102 : ProtocolErrMsg := 'EXEC: Error preparing for swap: program too low in memory';

      $0200 : ProtocolErrMsg := 'EXEC: Program file not found';
      $0201 : ProtocolErrMsg := 'EXEC: Program file: Invalid drive';
      $0202 : ProtocolErrMsg := 'EXEC: Program file: Invalid path';
      $0203 : ProtocolErrMsg := 'EXEC: Program file: Invalid name';
      $0204 : ProtocolErrMsg := 'EXEC: Program file: Invalid drive letter';
      $0205 : ProtocolErrMsg := 'EXEC: Program file: Path too long';
      $0206 : ProtocolErrMsg := 'EXEC: Program file: Drive not ready';
      $0207 : ProtocolErrMsg := 'EXEC: Batchfile/COMMAND: COMMAND.COM not found';
      $0208 : ProtocolErrMsg := 'EXEC: Error allocating temporary buffer';

      $0301..
      $03FF : ProtocolErrMsg := 'EXEC: DOS: ' + ErrorMessage(ProtocolError and $FF);
            { DOS-error-code xx calling EXEC }

      $0400 : ProtocolErrMsg := 'EXEC: Error allocating environment buffer';

      $0500 : ProtocolErrMsg := 'EXEC: Swapping requested, but prep_swap has not been called or returned an error.';
      $0501 : ProtocolErrMsg := 'EXEC: MCBs don''t match expected setup';
      $0502 : ProtocolErrMsg := 'EXEC: Error while swapping out';

      $0600 : ProtocolErrMsg := 'EXEC: RDIR: Redirection syntax error';
      $0601..
      $06FF : ProtocolErrMsg := 'EXEC: RDIR: DOS: ' + ErrorMessage(ProtocolError and $FF);
            { DOS error xx on redirection }
   Else
      ProtocolErrMsg := 'Protocol Error : ' + IntToStr(ProtocolError);
   End;
End;

Function PDriveParams : String;
Var
   Params : String;

Begin
   Params := '';
   Params := Params + '/B' + IntToStr(DoorSys.BaudRate) + ' ';
   Params := Params + '/C' + IntToStr(DoorSys.ComPort) + ' ';
   If Ctl.NSP Then
   Begin
      Params := Params + '/H' + Ctl.HexAddr + ' ';
      Params := Params + '/I' + IntToStr(Ctl.IRQ) + ' ';
   End;
   Params := Params + '/D';
   Case DoorSys.WhichIO Of
      InternalIO : Params := Params + '1 ';
        FossilIO : Params := Params + '2 ';
          DigiIO : Params := Params + '3 ';
   End;
   Case UserProtocol Of
      'X' : Params := Params + '/X ';
      '1' : Params := Params + '/K ';
      'Y' : Params := Params + '/Y ';
      'G' : Params := Params + '/G ';
      'Z' : Params := Params + '/Z ';
{$IFDEF VERSIONCHECK}
      'M' : Params := Params + '/M ';
{$ENDIF}
   End;

   Params := Params + '/P' + IntToStr(Ctl.PortSpeed) + ' ';
{$IFDEF VERSIONCHECK}
   If ActivityLog <> '' Then
      Params := Params + '/A=' + ActivityLog + ' ';
{$ENDIF}

   PDriveParams := Params;
End;

Function ExecuteProtocol(Params : String) : Integer;
Var
   TheDir : String;

Begin
   If Not PDriveInstalled Then Exit;

   Params := PDriveParams + Params;

   GetDir(0, TheDir);
   SaveScreen;
   DeInitComPort;
   ProtocolError := Do_Exec(PDriveLocation, Params, Use_All, $ffff, TRUE);
   If InitComPort Then ;
   RestoreScreen;
   ShowStatusBar;
   ChDir(TheDir);
   DoorSys.IdleCount := 0;
   UpdateTime;
   ProtocolErr;
   ExecuteProtocol := ProtocolError;
End;

Function LocalSend : Boolean;
Var
   u  : Byte;
   bs : String;
   Continue : Boolean;

Begin
   LocalSend := False;

   sGotoXY( 2, 5); IceText('Local download path : ', False);
   sGotoXY(24, 5); OutTxt(15, 1, Dup(' ', 50));
   sGotoXY(24, 5); OutTxt(15, 1, DstPath);
   DstPath := NormalInput(50, DstPath);
   Set_Color(7, 0);

   If DstPath = '' Then Exit;
   DstPath := FixPath(DstPath);
   If DExist(DstPath) Then
   Begin
      sWriteln('');
      u := 1;
      Continue := True;
      While (u <= FileCount) and (Continue) Do
      Begin
         bs := GetFilename(SendArray[u]);
         Case CopyFile(SendArray[u], DstPath + bs) Of
            0 : ;     { Copy Ok }
            1 : Begin { Source = Destination }
                   sWriteln('');
                   IceText(' Source and destination are the same', True);
                   Continue := False;
                End;
            2 : Begin { Problem opening Source }
                   sWriteln('');
                   IceText(' Error occured opening Source', True);
                   Continue := False;
                End;
            3 : Begin { Problem with destination }
                   sWriteln('');
                   IceText(' Error occured opening Destination', True);
                   Continue := False;
                End;
            4 : Begin { Problem during copy }
                   sWriteln('');
                   IceText(' Error occured while copying', True);
                   Continue := False;
                End;
         End;
         inc(u, 1);
      End;
      If Not Continue Then
      Begin
         sWriteln('');
         sWriteC(' ');
         AnyKey;
      End Else
      Begin
         FillChar(SendArray, SizeOf(SendArray), 0);
         FileCount := 0;
         LocalSend := True;
      End;
   End Else
   Begin
      sWriteln('');
      IceText(' Download path does not exist!!  ', True);
      sWriteln('');
      sWriteC(' ');
      AnyKey;
   End;
End;

Function Send : Boolean;
Var
   Params    : String;
   BatchList : Text;
   u         : Byte;

Begin
   Send := False;
   If FileCount = 0 Then Exit;

   Case UserProtocol of
      'X',
      '1'  : Begin
                Params := '/F=' + SendArray[1] + ' ';
                Log('Download : ' + SendArray[1]);
             End;
      'Y',
      'G',
{$IFDEF VERSIONCHECK}
      'Z',
      'M'  : Begin
{$ELSE}
      'Z'  : Begin
{$ENDIF}
                Assign(BatchList, 'BATCH.LST');
                Rewrite(BatchList);
                For u := 1 to FileCount Do
                Begin
                   Log('Download : ' + SendArray[u]);
                   Writeln(BatchList, SendArray[u]);
                End;
                Close(BatchList);
                Params := '/L=BATCH.LST ';
             End;
   End;

   sClrScr;
   OutTxt(9, 0, Dup('', 80));
   IceText(' File Transfer Protocol: ', False);
   Case UserProtocol of
      'L' : IceText('Local Download', True);
      'X' : IceText('Xmodem', True);
      '1' : IceText('Xmodem-1k', True);
      'Y' : IceText('Ymodem', True);
      'G' : IceText('YmodemG', True);
      'Z' : IceText('Zmodem', True);
{$IFDEF VERSIONCHECK}
      'M' : IceText('MaxModem', True);
{$ENDIF}
   End;
   IceText(' Start Receiving Your Files Now Or Press Ctrl-X Many Times To Abort...', True);
   OutTxt(9, 0, Dup('', 80));

   Case UserProtocol Of
      'L' : Send := LocalSend;
      'X',
      '1',
      'Y',
      'G',
{$IFDEF VERSIONCHECK}
      'Z',
      'M' : Begin
{$ELSE}
      'Z' : Begin
{$ENDIF}
               Params := Params + '/S ';
               If ExecuteProtocol(Params) = 0 Then
               Begin
                  FillChar(SendArray, SizeOf(SendArray), 0);
                  FileCount := 0;
                  Send := True;
               End;
            End;
   End;
{$IFDEF VERSIONCHECK}
   If UserProtocol in ['Y', 'G', 'Z', 'M'] Then FErase('BATCH.LST');
{$ELSE}
   If UserProtocol in ['Y', 'G', 'Z'] Then FErase('BATCH.LST');
{$ENDIF}
End;

Function LocalReceive(ReceivePath : String) : Boolean;
Var
   bs    : String;
   error : Boolean;

Begin
   ReceivePath := FixPath(ReceivePath);

   LocalReceive := False;

   sGotoXY( 2, 5); IceText('Local upload file : ', False);
   sGotoXY(22, 5); OutTxt(15, 1, Dup(' ', 50));
   sGotoXY(22, 5); OutTxt(15, 1, SrcFile);
   SrcFile := NormalInput(50, SrcFile);
   Set_Color(7, 0);

   If SrcFile = '' Then Exit;
   If FExist(SrcFile) Then
   Begin
      sWriteln('');
      Error := False;
      bs := GetFilename(SrcFile);
      Case CopyFile(SrcFile, ReceivePath + bs) of
         0 : ; { Copy Ok }
         1 : Begin { Source = Destination }
                sWriteln('');
                IceText(' Source and destination are the same', True);
                Error := True;
             End;
         2 : Begin { Problem opening Source }
                sWriteln('');
                IceText(' Error occured opening Source', True);
                Error := True;
             End;
         3 : Begin { Problem with destination }
                sWriteln('');
                IceText(' Error occured opening Destination', True);
                Error := True;
             End;
         4 : Begin { Problem during copy }
                sWriteln('');
                IceText(' Error occured while copying', True);
                Error := True;
             End;
      End;
      If Error Then
      Begin
         sWriteln('');
         AnyKey;
      End Else
         LocalReceive := True;
   End Else
   Begin
      sWriteln('');
      IceText(' Upload file does not exist!!  ', True);
      sWriteln('');
      AnyKey;
   End;
End;

Function Receive(Path : String) : Boolean;
Var
   Params : String;

Begin
   sClrScr;
   OutTxt(9, 0, Dup('', 80));
   IceText(' File Transfer Protocol: ', False);
   Case UserProtocol of
      'L' : IceText('Local Upload', True);
      'X' : IceText('Xmodem', True);
      '1' : IceText('Xmodem-1k', True);
      'Y' : IceText('Ymodem', True);
      'G' : IceText('YmodemG', True);
      'Z' : IceText('Zmodem', True);
{$IFDEF VERSIONCHECK}
      'M' : IceText('MaxModem', True);
{$ENDIF}
   End;
   IceText(' Start Sending Your Files Now Or Press Ctrl-X Many Times To Abort...', True);
   OutTxt(9, 0, Dup('', 80));

   Receive := False;
   If Not DExist(Path) Then MakeDir(Path);
   If Not Local Then
   Begin
      Params := '/R=' + FixPath(Path);
      If ExecuteProtocol(Params) = 0 Then
         Receive := True;
   End Else
      Receive := LocalReceive(Path);
End;

Function LocateFile(FName : String) : String;
Var
   F : String;

Begin
   LocateFile := '';
   If FExist(FName) Then
      LocateFile := FExpand(FName)
   Else
      LocateFile := FSearch(FName, GetEnv('PATH'));
End;

{$IFDEF VERSIONCHECK}
Procedure DetectPDriveVersion;
Var
   TheDir : String;

Begin
   If Not PDriveInstalled Then Exit;

   GetDir(0, TheDir);
   SaveScreen;
   DeInitComPort;
   PDriveVersion := Do_Exec(PDriveLocation, '/V', Use_All, $FFFF, TRUE);
   If InitComPort Then ;
   RestoreScreen;
   ShowStatusBar;
   ChDir(TheDir);
   DoorSys.IdleCount := 0;
   UpdateTime;
End;
{$ENDIF}

Procedure InitPDrive;
Begin
   PDriveLocation := Protocol.LocateFile('PDRIVE.EXE');
   PDriveInstalled := PDriveLocation <> '';
{$IFDEF VERSIONCHECK}
   DetectPDriveVersion;
{$ENDIF}
End;

Begin
   FillChar(SendArray, SizeOf(SendArray), 0);
   FileCount := 0;
   UserProtocol := 'Z';
   DstPath := '';
   SrcFile := '';
   InitPDrive;
End.
