Procedure Save_ANSi(Filename : String);
Const
  NumRows = 24;
  NumCols = 80;

Type ElementType = Record
     Ch          : Char;
     Attr        : Byte;
     End;
     ScreenType  = Array[1..NumRows,1..NumCols] of ElementType;

Const
  TextMask    = $07; { 0000 0111 }
  BoldMask    = $08; { 0000 1000 }
  BackMask    = $70; { 0111 0000 }
  FlshMask    = $80; { 1000 0000 }
  BackShft    = 4;
  ESC         = #$1B;
  ANSiColours : Array[0..7] of Byte = (0,4,2,6,1,5,3,7);

Var
  OutFile : Text;

Procedure ChangeAttr(Var OldAttr, NewAttr : Byte);
Var
  Connect : String[1];
Begin
  Connect := '';
  Write(Outfile, ESC, '['); {Begin sequence}
  If (OldAttr and (BoldMask + FlshMask)) <>     {Output flash & blink}
     (NewAttr and (BoldMask + FlshMask)) Then Begin
     Write(Outfile, '0');
     If NewAttr and BoldMask <> 0 Then Write(Outfile, ';1');
     If NewAttr and FlshMask <> 0 Then Write(Outfile, ';5');
     OldAttr := $FF;
     Connect := ';';   {Force other attr's to print}
  End;
  If (OldAttr and BackMask) <> (NewAttr and BackMask) Then Begin
     Write(OutFile, Connect, ANSiColours[(NewAttr and BackMask) Shr BackShft] + 40);
     Connect := ';';
  End;
  If (OldAttr and TextMask) <> (NewAttr and TextMask) Then
     Write(OutFile, Connect, ANSiColours[NewAttr and TextMask] + 30);
  Write(Outfile, 'm'); {Terminate sequence}
  OldAttr := NewAttr;
End;

Function AttrChanged(Attr : byte; ThisEl : ElementType) : Boolean;
Var
   Result : Boolean;

Begin
   Result := FALSE;
   If ThisEl.ch = ' ' Then
   Begin
      If (ThisEl.Attr and BackMask) <> (Attr and BackMask) Then
         Result := TRUE;
   End Else
      If ThisEl.Attr <> Attr Then
         Result := TRUE;
   AttrChanged := Result;
End;

Var
   Screen   : ScreenType Absolute $b800:0000;
   ThisAttr,
   TestAttr : Byte;
   LoopRow,
   LoopCol,
   LineLen  : Integer;

Begin
   Assign(OutFile, Filename);
   Rewrite(OutFile);

   ThisAttr := $FF;
   For LoopRow := 2 To NumRows Do Begin
      LineLen := NumCols;
      While (LineLen > 0) and (Screen[LoopRow, LineLen].Ch = ' ') And
      Not AttrChanged($00, Screen[LoopRow, LineLen]) Do
         Dec(LineLen, 1);

      For LoopCol := 1 to LineLen Do { Send Stream to File } Begin
         If AttrChanged(ThisAttr, Screen[LoopRow, LoopCol]) Then
            ChangeAttr(ThisAttr, Screen[LoopRow, LoopCol].Attr);
         Write(Outfile, Screen[LoopRow, LoopCol].Ch);
      End;
      If LineLen < 80 Then Writeln(OutFile);
   End;
   Close(OutFile);
End;
